program Call_suma_dinam;

uses
  Sharemem,
  SysUtils,
  Classes,
  Windows,
  Dialogs;

{$R *.res}

var
  H: Thandle;
  res:integer;
  Sum: function(x,y:Integer):integer; stdcall;
begin

  if (MessageBox(0, 'Desea cargar la DLL?', '', MB_ICONQUESTION or MB_YESNO) = idNo) then begin
    Exit;
  end;

  H := LoadLibrary('SUMAS.DLL');
  // Cargada correctamente?
  if (H >= 32) then begin
    MessageDlg('Cargada la DLL...', mtInformation, [mbOK], 0);
    sum := nil;
    @sum := GetProcAddress(H, 'Sumar2');
    // Asignada?
    if Assigned(sum) then begin
      MessageDlg('Acceso a la funcin SUMAR', mtInformation, [mbOK], 0);
      // llamada
      res := Sum(4,5);

      MessageDlg(Format('Resultado:  %d+%d=%d',[4,5,res]), mtInformation, [mbOK], 0);
      FreeLibrary(H);
    end;
  end
  else
    MessageDlg('Error, no se ha encontrado SUMAR.DLL', mtError, [mbOk], 0)
 end.
end.
