unit UCallRestas_din;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type

  //: Tipo para ejecutar un mtodo de clase RunMultiSelecc
  TExecuteExecForm = procedure() of object;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  H: Thandle;
  res:integer;
  resta: function(x,y:Integer):integer;
begin

  if (MessageBox(0, 'Desea cargar la BPL?', '', MB_ICONQUESTION or MB_YESNO) = idNo) then begin
    Exit;
  end;

  H := LoadPackage('RESTAS.BPL');
  // Cargado correctamente?
  if (H > 0) then begin
    MessageDlg('Cargado el package...', mtInformation, [mbOK], 0);
    resta := nil;
    @resta := GetProcAddress(H, 'Resta');
    // Asignada?
    if Assigned(resta) then begin
      MessageDlg('Acceso a la funcin RESTAR', mtInformation, [mbOK], 0);
      // llamada
      res := resta(10,7);

      MessageDlg(Format('Resultado:  %d-%d=%d',[10,7,res]), mtInformation, [mbOK], 0);
    end;

    // descargar
    UnloadPackage(H);
  end
  else
    MessageDlg('Error, no se ha encontrado RESTAR.BPL', mtError, [mbOk], 0)
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  H: Thandle;
  AClass: TPersistentClass;
  F:TForm;
begin

  H := LoadPackage('RESTAS.BPL');
  // Cargado correctamente?
  if (H > 0) then begin
    MessageDlg('Cargado el package...', mtInformation, [mbOK], 0);
    AClass := GetClass('TFormMain');
    // encontrada
    if Assigned(AClass) then begin

      // Cear el form
      F := TFormClass(AClass).Create(nil);
      F.ShowModal;
      F.Free;
    end
    else begin
      MessageDlg('Error, no se ha encontrado la clase TFormMain en el package RESTAR.BPL', mtError, [mbOk], 0);
    end;

    UnloadPackage(H);
  end
  else begin
    MessageDlg('Error, no se ha encontrado RESTAR.BPL', mtError, [mbOk], 0);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  H: Thandle;
  AClass: TPersistentClass;
  F:TForm;
  FormClass:TFormClass;
  Routine: TMethod;
begin

  H := LoadPackage('RESTAS.BPL');
  // Cargado correctamente?
  if (H > 0) then begin
    MessageDlg('Cargado el package...', mtInformation, [mbOK], 0);
    AClass := GetClass('TFormMain');
    // encontrada
    if Assigned(AClass) then begin

      // Acceder a la clase
      FormClass := TFormClass(AClass);
      // Crear el form
      F := FormClass.Create(nil);

      // Acceder al mtodo
      Routine.Data := Pointer((F as FormClass));
      // Ejecutar al cdigo
      Routine.Code := (F as FormClass).MethodAddress('ExecForm');

      // No ha encontrado el cdigo de la rutina...
      if (Routine.Code <> nil) then begin
        // Ejecutarlo
        TExecuteExecForm(Routine);
      end;

      FreeAndNil(F);
    end
    else begin
      MessageDlg('Error, no se ha encontrado la clase TFormMain en el package RESTAR.BPL', mtError, [mbOk], 0);
    end;

    UnloadPackage(H);
  end
  else begin
    MessageDlg('Error, no se ha encontrado RESTAR.BPL', mtError, [mbOk], 0);
  end;
end;

end.
